// noisePhoticles_limni3_GG3.pde
// 2-7-2017
//
/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/133331*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */

final int STAGE_WIDTH = 1280;
final int STAGE_HEIGHT = 800;
//final int NB_PARTICLES = 40000;
final int NB_PARTICLES = 15000;//20000 de 5 à 40000

float MAX_PARTICLE_SPEED = 1.5;
//final float PARTICULE_SIZE = 100;
final float MAX_DISTANCE = sqrt(STAGE_WIDTH*STAGE_WIDTH + STAGE_HEIGHT*STAGE_HEIGHT);

float MIN_STEP_NOISE = 0.01;
//final float MAX_STEP_NOISE = 0.004;//0.01;
float MAX_STEP_NOISE = 0.0008;//0.01;
final float MIN_SPEED_NOISE = -.003;
final float MAX_SPEED_NOISE = .009;
//final float MAX_SPEED_NOISE = .03;
final int MIN_LIFE_TIME = 18;//GOOD
final int MAX_LIFE_TIME = 45040;//GOOD
float hhh, LimniMini, LimniMaxi;
//'root' of the noise
float noiseX;
float noiseY;
//used to move the noise - or not
float noiseSpeedX;
float noiseSpeedY;
//noise step (the smaller, the better granularity)
float stepNoiseX;
float stepNoiseY;

//influence circle of the mouse
final float MAX_DIST_MOUSE_SQUARE = 550;
final float MAX_DIST_MOUSE = sqrt(MAX_DIST_MOUSE_SQUARE);
myVector tabParticles[];//array of particles
Boolean mouseRepels = false;//allows the mouse to repel the particles

//picture
//final String IMAGE_PATH = "crue2.jpg";//landscape nature lao
PImage []myImage;
//int nnn = 0;
int NbrImage = 6; // Nombre d'images myImage0.jpg myImage1.jpg ...
int nnn = 0;

int imageW;
int imageH;
color myPixels[];

float coeffColor;

int savedTime;
int totalTime = 15000;

void setup() {
  size(1280, 800, P3D);
  savedTime = millis();
  background(0);
  cocosetup();
  myImage=new PImage[6];
  for (int i=0; i<6; i++) {
    myImage[i]= loadImage("img"+i+".jpg");
  }
  initializeImage();
  initializeNoise();
}

void initializeImage() { 
  image(myImage[nnn], 0, 0);
  imageW = myImage[nnn].width;
  imageH = myImage[nnn].height;
  myPixels = new color[imageW * imageH];
  myImage[nnn].loadPixels();
  myPixels = myImage[nnn].pixels;
  myImage[nnn].updatePixels();
}

void initializeNoise()
{
  int myX;
  int myY;
  noiseX = random(12);
  noiseY = random(12);
  noiseSpeedX = random(MIN_SPEED_NOISE, MAX_SPEED_NOISE);
  noiseSpeedY = random(MIN_SPEED_NOISE, MAX_SPEED_NOISE);
  stepNoiseX = random(MIN_STEP_NOISE, MAX_STEP_NOISE);
  stepNoiseY = random(MIN_STEP_NOISE, MAX_STEP_NOISE);
  tabParticles = new myVector[NB_PARTICLES];
  for (int i = 0; i < NB_PARTICLES; i++)
  {
    myX = (int)random(imageW);
    myY = (int)random(imageH);
    tabParticles[i] = new myVector(myX, myY);
    tabParticles[i].prevX = tabParticles[i].x;
    tabParticles[i].prevY = tabParticles[i].y;
    tabParticles[i].count = (int)random(MIN_LIFE_TIME, MAX_LIFE_TIME);
    tabParticles[i].myColor = myPixels[(int)(tabParticles[i].y)*imageW + (int)(tabParticles[i].x)];
  }
}

void draw() {
  CalculIndiceLimni();
  if (Affiche) {
    fill(0);
    rect(0, 0, 250, 50);
    fill(255);
    textSize(24);
    // text(Limni[IndiceLimni] / 10 + "cm", 20, 40);
    text("IndiceLimni = " + IndiceLimni, 20, 40);
  }
  //noStroke(); 
  //rect(0, 0, width, height);
  //image(myImage[nnn], 0, 0, width, height);
  //sortHappens=false;
  int passedTime = millis() - savedTime;
  totalTime = int(map(Limni[IndiceLimni], 0, 3500, 7000, 100));
  // Has five seconds passed?
  if (passedTime > totalTime) {
    // println("5 seconds have passed!");
    println("Durée image = " + totalTime + " ms  IndiceLimni = " + IndiceLimni + "   Limni[IndiceLimni] = " + Limni[IndiceLimni]);
    tempsPasse();
    savedTime = millis(); // Save the current time to restart the timer!
  }
  noiseX += noiseSpeedX;
  noiseY += noiseSpeedY;
  float n;
  float distMouse;
  float vx;
  float vy;
  float dx;
  float dy;
  //PVector mouseVector = new PVector(mouseX, mouseY);
  //if(millis()>5000)
  //if(millis() > m + 5000)
  for (int i = 0; i < NB_PARTICLES; i++)
  {
    tabParticles[i].prevX = tabParticles[i].x;
    tabParticles[i].prevY = tabParticles[i].y;

    n = noise(noiseX+tabParticles[i].x*stepNoiseX, noiseY+tabParticles[i].y*stepNoiseY);

    vx = (n-1)*2*cos((n-.16) * TWO_PI)*MAX_PARTICLE_SPEED;
    //   // vx = (n-1)*2*cos((n-.2) * TWO_PI);//variable pour (n-.variable)

    vy = (n-1)*2*tan(n * TWO_PI)*MAX_PARTICLE_SPEED;

    //vx = (n-1)*2*cos((n-.16) * TWO_PI)*MAX_PARTICLE_SPEED;
    //vy = (n-1)*2*sin(n * TWO_PI)*MAX_PARTICLE_SPEED;


    dx = mouseX - tabParticles[i].x; 
    dy = mouseY - tabParticles[i].y;
    distMouse = dx*dx+dy*dy;
    if (mouseRepels && (distMouse < MAX_DIST_MOUSE_SQUARE))
    {
      distMouse = sqrt(distMouse);
      float f = MAX_DIST_MOUSE / distMouse;
      vx -= f*dx; 
      vy -= f*dy;
    }
    //vx = constrain(vx, -MAX_PARTICLE_SPEED, MAX_PARTICLE_SPEED);
    //vy = constrain(vy, -MAX_PARTICLE_SPEED, MAX_PARTICLE_SPEED);

    tabParticles[i].x += vx;
    tabParticles[i].y += vy;
    tabParticles[i].count++;
    if ((tabParticles[i].x < 0) || (tabParticles[i].x > imageW-1) || 
      (tabParticles[i].y < 0) || (tabParticles[i].y > imageH-1) ||
      tabParticles[i].count > MAX_LIFE_TIME)
    {
      float myX = 0;
      float myY = 0;
      //prevents from reappearing inside the mouse influence
      if (mouseRepels)
      {
        Boolean isFound = false;
        while (!isFound)
        {
          myX = random(imageW);
          myY = random(imageH);

          dx = mouseX - myX;
          dy = mouseY - myY;
          if (dx*dx + dy*dy > MAX_DIST_MOUSE_SQUARE)
          {
            isFound = true;
          }
        }
      } 
      else
      {
        //myX = random(imageW);
        //myY = random(imageH);
        myX = random(120);
        myY = random(120);
      }
      tabParticles[i].x = tabParticles[i].prevX = myX;
      tabParticles[i].y = tabParticles[i].prevY = myY;
      tabParticles[i].count = (int)random(MIN_LIFE_TIME, MAX_LIFE_TIME);
      n = noise(noiseX+myX*stepNoiseX, noiseY+myY*stepNoiseY);
      tabParticles[i].myColor = myPixels[(int)(tabParticles[i].y)*imageW + (int)(tabParticles[i].x)];
    }
    strokeWeight(sqrt(vx*vx + vy*vy)*n*3.679);//GOOD mettre variable
    stroke(tabParticles[i].myColor, 80);//GOOD
    line(tabParticles[i].prevX, tabParticles[i].prevY, tabParticles[i].x, tabParticles[i].y);
    //line(tabParticles[i].prevX-2, tabParticles[i].prevY+2, tabParticles[i].x-2, tabParticles[i].y+2);
    //line(tabParticles[i].prevX-2, tabParticles[i].prevY-2, tabParticles[i].x-2, tabParticles[i].y-2);
  }

  // image(myImage[int(TempsMillis /1000/ Div) % NbrImage], 15000, 2000);
  // image(myImage[int(TempsMillis /1000/ Div) % NbrImage], 0, 0);
  MAX_PARTICLE_SPEED = map(Limni[IndiceLimni], 0, 2500, random(0.001, 0.004), random(5, 7.6));
  MAX_STEP_NOISE = map(Limni[IndiceLimni], 0, 2500, 0.004, 0.01);
  MIN_STEP_NOISE = map(Limni[IndiceLimni], 0, 2500, 0.0004, 0.001);

  cocodraw();

  //println(MAX_PARTICLE_SPEED);
}

void mousePressed()
{
  if (mouseButton == LEFT)
  {
    //nnn = nnn+1;
    //if (nnn>5) nnn = 0;

    //initializeImage();
    //initializeNoise();
  } 
  else if (mouseButton == RIGHT)
  {
    mouseRepels = true;
  }
}

void mouseReleased() {  
  mouseRepels = false;
}

class myVector extends PVector {
  myVector (float p_x, float p_y)
  {
    super(p_x, p_y);
  }
  float prevX;
  float prevY;
  int count;
  color myColor;
}

void tempsPasse() { 
  nnn = nnn+1;
  if (nnn >= NbrImage) nnn = 0;
  initializeImage();
  // initializeNoise();
  if ((nnn % 4) == 1) initializeNoise();
  println("nnn = " + nnn);
}

